#include <DS1307.h>
#include <TimeLib.h>
#include <Wire.h>
#include <Arduino.h>
#include <LiquidCrystal.h>  
#include <phi_interfaces.h>
#include <phi_prompt.h> //modfied to support IDE 1.58 and upwards 
#include <OneWire.h>
#include <DallasTemperature.h>
 
#define lcd_rows 4
#define lcd_columns 20
#define EncoderDetent 20
#define btn_u 8
#define btn_d 8
#define btn_l 8
#define btn_r 8
#define btn_b 8
#define btn_a 8
#define btn_null 0
#define total_buttons 6


#define pinEN 13
#define pinIP1 12
#define pinIP2 11
#define FLED 10



#define RTC_DS 9
#define Encoder1_SW 8
#define LCD_RS 7
#define LCD_EN 6
#define LCD_D4 5
#define LCD_D5 4
#define LCD_D6 3
#define LCD_D7 2
#define Encoder1ChnA 0
#define Encoder1ChnB 1
#define ONE_WIRE_BUS A2
#define backLight A3

// Anlogue pinouts

#define pinLiT A1
#define pinLiB A0
#define STOP 0
#define UP 1
#define DOWN -1
#define DoorDown 68
#define DoorUp 85
#define Overide 90
#define debounce_delay 50
#define NumKeys 5

// Create hardware objects

LiquidCrystal lcd(LCD_RS,LCD_EN,LCD_D4,LCD_D5,LCD_D6,LCD_D7); // Create the lcd object

OneWire oneWire(ONE_WIRE_BUS);

DallasTemperature sensors(&oneWire);


// Global variables

int rtc[RTC_DS];
int GlobTime, WakeTime, BedTime, Flash, stateMotor,door_action, adc_key_in, key=-1, oldkey=-1, toggle=HIGH, BST_flag;
char buf[6];
float MaxTReading, MinTReading, TReading;
int isLcdLightOn = false;
int adc_key_val[5] ={ 30, 150, 360, 535, 760 };
int UpRate=500;
int DownRate=200;
int backLightTime=300;
int MotorFailSafe = 10;
int MotorOnTime;
int SetFlashOn = false;
int SetFlashRedOn = false;


char mapping1[]={'U','D'}; // This is a rotary encoder so it returns U for up and D for down on the dial.
phi_rotary_encoders my_encoder1(mapping1, Encoder1ChnA, Encoder1ChnB, EncoderDetent);
char mapping[]={1,2,3,4,5,6}; // This is a list of names for each button.
byte pins[]={btn_null,btn_null,btn_null,btn_null,btn_b,btn_null}; // The digital pins connected to the 6 buttons.
phi_button_groups my_btns(mapping, pins, total_buttons);
multiple_button_input * keypads[]={&my_btns,&my_encoder1,0};

char up_keys[]={'U',0}; ///< All keys that act as the up key are listed here.
char down_keys[]={'D',0}; ///< All keys that act as the down key are listed here.
char left_keys[]={'U',0}; ///< All keys that act as the left key are listed here.
char right_keys[]={'D',0}; ///< All keys that act as the right key are listed here.
char enter_keys[]={5,0}; ///< All keys that act as the enter key are listed here.
char escape_keys[]={5,0}; ///< All keys that act as the escape key are listed here.
char * function_keys[]={up_keys,down_keys,left_keys,right_keys,enter_keys,escape_keys}; ///< All function key names are gathered here fhr phi_prompt.

PROGMEM const char msg_00[]="CCC v4 by Perry Childs";



void setup()
{
  sensors.begin();
  lcd.begin(lcd_columns, lcd_rows);
  init_phi_prompt(&lcd,keypads,function_keys, lcd_columns, lcd_rows, '~'); // Supply the liquid crystal object, input keypads, and function key names. Also supply the column and row of the lcd, and indicator as '>'. You can also use '\x7e', which is a right arrow.
  coop_initialise();
}



void loop()
{
  top_menu();
}







